var points
$.ajaxSettings.async = false
$.getJSON("./demo.json", function (data) {
    points = [].concat.apply([], data.map(function (track) {
        return track.map(function (seg) {
            return seg.coord.concat([Math.floor(Math.random() * (5)) + 1])
        })
    }))
})
function heatMap(dom) {
    this.container = dom
    this.chart = echarts.init(dom)
    this.map
    this.isMock = true
    this.items = []
    this.maxNum
    this.aggregation = null
    this.options = {}
    // this.render()
}

heatMap.prototype.render = function () {
    this.chart.clear()
    this.container.style.opacity = this.isMock ? 0.3 : 1

    var items = this.isMock ? heatMap.mockItems : this.items
    var options = this.isMock ? heatMap.defaultOptions : this.options
    var maxNumber = this.isMock ? 15 : this.maxNum * 3
    var option = {
        animation: false,
        bmap: {
            center: options.center,
            zoom: options.zoom,
            roam: true,
        },
        visualMap: {
            type: 'continuous',
            show: false,
            top: 'top',
            min: 0,
            max: maxNumber,
            dimension:2,
            seriesIndex: 0,
            calculable: true,
            inRange: {
                color: options.color
            }
        },
        series: [{
            type: 'heatmap',
            coordinateSystem: 'bmap',
            data: items,
            pointSize: 5,
            blurSize: 6
        }]
    }
    this.chart.setOption(option)
    this.map = this.chart.getModel().getComponent('bmap').getBMap()
    var style = options.mapStyle.style  //style控制地图样式
    var styleId = options.mapStyle.styleId  //styleId控制地图样式
    if(style) {
        this.map.setMapStyle({
            style: style
        });
    }
    if(styleId) {
        this.map.setMapStyleV2({
            styleId: styleId
        });
    }

    var that = this
    this.map.addEventListener('dragend', function() {
        var center = that.map.getCenter()
        that.options.center = [center.lng, center.lat]
        that.parseOptions(that.options)
    })

    this.map.addEventListener('zoomend', function() {
        that.options.zoom = that.map.getZoom()
        that.parseOptions(that.options)
    })
}

heatMap.prototype.validate = function (aggregation) {
    return aggregation && aggregation.values.length > 0 && aggregation.dimensions.length > 0
}

heatMap.prototype.update = function (aggregation, options) {
    this.options = this.parseOptions(options)
    if (!this.validate(aggregation)) {
        this.isMock = true
        this.render()
        return
    }
    this.isMock = false
    var datas = aggregation.data
    var dim = aggregation.dimensions
    var value = aggregation.values[0]
    var arr = []
    var arrNum = []
    datas.map(function (item) {
        arr.push([item[dim[0]],item[dim[1]],item[value]])
        arrNum.push(item[value])
    })
    this.items = arr
    this.maxNum = Math.max(...arrNum)
    this.aggregation = aggregation

    this.render()
}

heatMap.prototype.parseOptions = function (options) {
    var opt = options || {}
    var obj = {}
    var defaultOptions = heatMap.defaultOptions

    for (var att in defaultOptions) {
        obj[att] = opt[att] === void 0 ? defaultOptions[att] : opt[att]
    }

    WebContent.syncOptions(obj)
    return obj
}

heatMap.prototype.resize = function () {
    this.chart.resize()
}

heatMap.mockItems = points
heatMap.defaultOptions = {
    zoom: 14,
    center: [120.14066322374, 30.250018034923],
    color: ['blue', 'blue', 'green', 'yellow', 'red'],
    mapStyle: {
        style: 'normal'
    }
}

var dom = document.getElementById('root')
var myChart = new heatMap(dom)

//初始化web content
WebContent.init(function onUpdate(aggregation, options) {
    //当聚合数据变化时, 重新渲染chart
    myChart.update(aggregation, options)
})

//监听resize事件, 确保chart占满iframe
window.addEventListener('resize', function () {
    myChart.resize()
})